   Member

   Include ( 'zint_class.inc'  ), Once
   Pragma  ( 'link (zint.lib)' )

! GDI+
GdiplusToken                   ulong(0)
adr_Gdiplus                    long
h_GdiplusStartup               long, name('_GdiplusStartup')
h_GdiplusShutdown              long, name('_GdiplusShutdown')
h_GdipCreateBitmapFromHBITMAP  long, name('_GdipCreateBitmapFromHBITMAP')
h_GdipCloneBitmapAreaI         long, name('_GdipCloneBitmapAreaI')
h_GdipGetImageEncoders         long, name('_GdipGetImageEncoders')
h_GdipGetImageEncodersSize     long, name('_GdipGetImageEncodersSize')
h_GdipSaveImageToFile          long, name('_GdipSaveImageToFile')
h_GdipLoadImageFromFile        long, name('_GdipLoadImageFromFile')
h_GdipSaveImageToStream        long, name('_GdipSaveImageToStream')
h_GdipDisposeImage             long, name('_GdipDisposeImage')

! msvcrt.dll
adr_msvcrt  long
h_size      long, name('f_size')
h_open      long, name('f_open')
h_read      long, name('f_read')
h_close     long, name('f_close')

GUID_T Group, Type
Data1  ulong  
Data2  ushort  
Data3  ushort  
Data4  byte, dim(8).

CLSID_T  like(GUID_T)

ImageCodecInfo_T  Group, Type
ClassID            Group(CLSID_T). 
FormatID           Group(GUID_T). 
CodecName          &ushort 
DllName            &ushort 
FormatDescription  &ushort 
FilenameExtension  &ushort 
MimeType           &ushort 
Flags              ulong 
Version            ulong 
SigCount           ulong 
SigSize            ulong 
SigPattern         &byte 
SigMask            &byte.

EncoderParameter_T  Group, Type   
Guid            Group(GUID_T).               
NumberOfValues  ulong    
Type            ulong               
Value           long.       

EncoderParameters_T  Group, Type
Count      ulong
Parameter  Group(EncoderParameter_T)..

CLSID  Queue
extp   string(4)
CLSID  Group(CLSID_T).
end  

PixelFormat Queue
index  long
val    long
end  

is_LoadLibs  long(0)

   Map

      Module('winapi')
         LoadLibrary    (*cstring lpLibFileName), long, raw, Pascal, dll(1), name('LoadLibraryA')             
         GetProcAddress (long hModule, *cstring lpProcName), long, raw, Pascal, dll(1)
         FreeLibrary    (long hLibModule), long, Pascal, dll(1), Proc

         CreateStreamOnHGlobal (long hGlobal,long fDeleteOnRelease, *long ppstm), long, Pascal, dll(1), Proc
         GetHGlobalFromStream  (long ppstm, *long hGlobal), long, Pascal, dll(1), Proc
         GlobalAlloc           (ulong uFlags=042H, ulong dwBytes), long, Pascal, dll(1)
         GlobalFree            (long hMem), long, Pascal, dll(1), Proc
         GlobalLock            (long hMem), long, Pascal, dll(1)
         GlobalUnlock          (long hMem), long, Pascal, dll(1)
         GlobalSize            (long hMem), ulong, Pascal, dll(1)
         
         memcpy(long dest, long src, long), long, Proc, name('_memcpy')
         GetLastError(), long, Pascal, dll(1)
         
         WideCharToMultiByte(ulong CodePage, ulong dwFlags, long lpWideCharStr,  long cchWideChar, long lpMultiByteStr, long cbMultiByte, long lpDefaultChar=0, long lpUsedDefaultChar=0), long, Pascal, Proc
         MultiByteToWideChar(ulong CodePage, ulong dwFlags, long lpMultiByteStr, long cbMultiByte, long lpWideCharStr, long cchWideChar), long, Pascal, Proc
         
         CLSIDFromString(*cstring lpsz, *CLSID_T pclsid), long, Pascal, raw, dll(1), Proc
      .

      Module('GDI32')
         CreateBitmap       (long nWidth, long nHeight, ulong nPlanes, ulong nBitCount, ulong lpBits), ulong, Pascal, dll(1)
         CreateCompatibleDC (ulong hdc), ulong, Pascal, dll(1)
         SelectObject       (ulong hdc, ulong hObject), ulong, Pascal, Proc, dll(1)
         DeleteObject       (ulong hObject), ulong, Pascal, Proc, dll(1)
         DeleteDC           (ulong hdc), long, Pascal, Proc, dll(1)
         ReleaseDC          (long hWnd, ulong hdc), long, Pascal, Proc, dll(1)
      .
      
      Module('GDIplus')
         GdiplusStartup              (*ulong token, *string input, *string output), ulong, Pascal, raw, dll(1), name('_GdiplusStartup')  
         GdiplusShutdown             (ulong token), Pascal, dll(1), name('_GdiplusShutdown')
         GdipCreateBitmapFromHBITMAP (ulong hbm, ulong hpal, *ulong bitmap), ulong, Pascal, dll(1), Proc, name('_GdipCreateBitmapFromHBITMAP')
         GdipCloneBitmapAreaI        (long x, long y, long width, long height, long format, ulong srcBitmap, *ulong dstBitmap), ulong, Pascal, dll(1), Proc, name('_GdipCloneBitmapAreaI')
         GdipGetImageEncoders        (ulong numEncoders, ulong size, *string array_encoders), ulong, Pascal, raw, dll(1), name('_GdipGetImageEncoders')
         GdipGetImageEncodersSize    (*ulong numEncoders, *ulong size), ulong, Pascal, dll(1), name('_GdipGetImageEncodersSize')
         GdipSaveImageToStream       (ulong Image, ulong Stream, *CLSID_T clsidEncoder, long encoderParams=0), ulong, Pascal, raw, dll(1), Proc, name('_GdipSaveImageToStream')
         GdipSaveImageToFile         (ulong Image, *string filename, *CLSID_T clsidEncoder, long encoderParams=0), ulong, Pascal, raw, dll(1), name('_GdipSaveImageToFile')
         GdipDisposeImage            (long image), ulong, Pascal, dll(1), Proc, name('_GdipDisposeImage')
      .

      Module('msvcrt')
         fsize  (long fd), long, C, dll(1), name('f_size')
         fopen  (*cstring filename, long access=4000h), long, raw, C, dll(1), name('f_open') ! TEXT=0x4000 BINARY=0x8000 
         fread  (long fd, *string buf, ulong count), long, raw, C, dll(1), Proc, name('f_read')
         fclose (long fd), long, raw, C, dll(1), Proc, name('f_close')
      .

      Gdiplus_Init(), long, Proc
      GetArrayEncoderClsid(), long

      load_libs (), long, Proc, Private
      load_file (any filename, *long filelength), *string, Private

      AtoU8     (*string source, long length, *long UTF8_length, ulong CP_input=0), *string
      AtoU16    (*string source, ulong CP_input=0), *string 
      U16toA    (*string source, ulong CP_input=0), *string

   .


!----------------------------------------------------------------------------------------------------------------------------------
zintClass.Construct  Procedure()

   Code 

      !  
      If load_libs() then is_LoadLibs = -1.

      !  GDI+
      If ~is_LoadLibs and Gdiplus_Init() then is_LoadLibs = -2.
      
   Return


!----------------------------------------------------------------------------------------------------------------------------------
zintClass.Destruct  Procedure()

   Code  

      self.ZB_Delete()
      
      GdiplusShutdown(GdiplusToken)
      
      FreeLibrary(adr_Gdiplus)
      FreeLibrary(adr_msvcrt)

   Return


!----------------------------------------------------------------------------------------------------------------------------------
zintClass.ZB_Create   Procedure()
!
!   ZS
! 
   Code 

      If is_LoadLibs then Return is_LoadLibs.

      adrZS# = ZBarcode_Create()
      If adrZS# = 0 then
         Return 0
       else  
         memcpy(address(self.ZS), adrZS#, size(self.ZS))
      . 

   Return  0

 
!----------------------------------------------------------------------------------------------------------------------------------  +
zintClass.ZB_Delete   Procedure()
!
!   ZS
!
   Code 

      ZBarcode_Delete(self.ZS)
      
   Return


!----------------------------------------------------------------------------------------------------------------------------------  +
zintClass.ZB_Clear   Procedure()
!
!   ZS
!
   Code 

      ZBarcode_Clear(self.ZS)

   Return


!----------------------------------------------------------------------------------------------------------------------------------
zintClass.ZB_Encode_and_Buffer   Procedure(any source, long length, long rotate_angle)
!
!  -   
!
! source       -   -    (string  string)    ,
!                string    ,  chr(0)    
!
! length       -  ,    source
!                 length = 0 source    chr(0)
!
! rotate_angle -  ,       (0, 90, 180  270)
!
zcs_source    &cstring

   Code 

      len_source# = len(source)
      zcs_source  &= new CString(len_source# + 1)
      zcs_source  = source 
      ret# = ZBarcode_Encode_and_Buffer(self.ZS, zcs_source, length, rotate_angle)

   Return   ret#


!----------------------------------------------------------------------------------------------------------------------------------  +
zintClass.ZB_ValidID   Procedure(long symbol_id)
!
!    ,    symbol_id -.
!    ,   - .
!
   Code 

   Return   ZBarcode_ValidID(symbol_id)


!----------------------------------------------------------------------------------------------------------------------------------  +
zintClass.ZB_Version   Procedure()
!
!    .
!
   Code 

   Return   ZBarcode_Version()


!----------------------------------------------------------------------------------------------------------------------------------
zintClass.ZB_File_Image  Procedure (any filename, long rotate_angle, long AU, any NFE, long pixel_format, ulong CP_input)
!
!  -   ,  ,        
!
! filename     -   - ,   (ANSI  UTF-8)  
!
! rotate_angle -  ,       (0, 90, 180  270)
!
! AU           -  , ,      filename
!                 AU=1      UTF8
!                 AU=0    ,     -,  ASCII,  
!                    UTF-8  
!
! NFE          - , :
!                           (.)         +   
!                              (bmp, gif, png, jpeg  tiff)     
!                         TIFF   Clarion-
!
! pixel_format -   (1, 4, 8, 16, 24  32)   bmp, png  tiff 
!                 gif  pixel_format   8, 16, 24  32 (  ),     -   8
!                 jpeg  pixel_format   8, 16, 24  32 (  ),     -   24
!                       -> PNG-1
! 
! CP_input     -  ,   - 
!
file_content &string

   Code
      
      file_content &= load_file(filename, filelength#)

   Return self.ZB_Str_Image(file_content, 0, rotate_angle, AU, NFE, pixel_format, CP_input)


!----------------------------------------------------------------------------------------------------------------------------------
zintClass.ZB_Str_Image   Procedure(any source, long how_to_clip, long rotate_angle, long AU, any NFE, long pixel_format, ulong CP_input)
!
!  -   ,  ,    
!
! source       -   -    (string  string)    
!
! how_to_clip  -  ,       
!                how_to_clip=-11 -> clip( left() ) 
!                how_to_clip=-10 -> left() 
!                how_to_clip=-01 -> clip() 
!                how_to_clip=  0 ->     
!
! rotate_angle -  ,       (0, 90, 180  270)
!
! AU           -  , ,      source 
!                 AU=1      UTF8
!                 AU=0    ,     -,  ASCII,  
!                    UTF-8  
!
! NFE          - , :
!                           (.)         +   
!                              (bmp, gif, png, jpeg  tiff)     
!                         TIFF   Clarion-
!
! pixel_format -   (1, 4, 8, 16, 24  32)   bmp, png  tiff 
!                 gif  pixel_format   8, 16, 24  32 (  ),     -   8
!                 jpeg  pixel_format   8, 16, 24  32 (  ),     -   24
!                       -> PNG-1
! 
! CP_input     -  ,   - 
!
! Mem2Str      -   ,    -        
!
zs_source    &string
zs_src_tmp   &string
utf8_string  &string
utf8_length  long

BitMap       &string
rgb          string(3)
ret          ulong

filename_w   &string
filename     &string
image_format &string
name_file    &string
SNFE         &string

Hbitmap_DIB  ulong
hDC          ulong
GpImg        ulong
GpImg_clone  ulong

Mem2Str      &string

GMem         long
GImage       long
GStream      long

err          string('error')

   Code
 
      len_source# = len(source)

      !       
      If len_source# = 0 then self.ZS.errtxt = ('ZB_Str_Image:      source') ; Return err.
      If ~inlist(how_to_clip, 0, -01, -10, -11) then self.ZS.errtxt = ('ZB_Str_Image:    how_to_clip : ' & how_to_clip) ; Return err.
      If ~inlist( rotate_angle, 0, 90, 180, 270 ) then self.ZS.errtxt = ('ZB_Str_Image:     rotate_angle : ' & rotate_angle) ; Return err.
      If ~inlist( AU, 0, 1 ) then self.ZS.errtxt = ('ZB_Str_Image:    AU : ' & AU) ; Return err.
      
      pl# = len( left(clip(NFE)) )
      If pl#=0 then self.ZS.errtxt = ('     NFE : ' & NFE) ; Return err.
      SNFE &= new String(pl#)
      SNFE = NFE
      pp# = instring('.', SNFE, -1, pl#)
 
      Case pp#
           of 0
              name_file    &= 0
              image_format &= SNFE[pp# + 1 : pl#]
           of 1
              self.ZS.errtxt = ('ZB_Str_Image:     : ' & SNFE) ; Return err
           else
              name_file    &= SNFE[1 : pp# - 1]
              image_format &= SNFE[pp# + 1 : pl#]
      .
 
      CLSID.extp = upper( left( image_format ) )
      Get( CLSID, CLSID.extp )
      If errorcode() then self.ZS.errtxt = ('ZB_Str_Image:    : ' & upper( image_format)) ; Return err.
      
      PixelFormat.index = pixel_format 
      Get(PixelFormat, PixelFormat.index)
      If errorcode() then self.ZS.errtxt = ('ZB_Str_Image:    pixel_format : ' & pixel_format) ; Return err.
      
      !       
      zs_src_tmp &= new String( len_source# )
      zs_src_tmp = source

      b_str# = 1 
      e_str# = len_source#
      Loop i# = 1 to len_source#
           If zs_src_tmp[i#] <> chr(32) then b_str# = i# ; break.
      .
      Loop i# = len_source# to 1 by -1
           If zs_src_tmp[i#] <> chr(32) then e_str# = i# ; break.
      .

      !           how_to_clip 
      Case how_to_clip
           of  -10  ! left() 
               zs_source  &= new String( len_source# - b_str# + 1 )
               zs_source  = zs_src_tmp[b_str# : len_source#]
           of  -01  ! clip() 
               zs_source  &= new String( e_str# )
               zs_source  = zs_src_tmp[1 : e_str#]
           of  -11  ! clip(left()) 
               zs_source  &= new String( e_str# - b_str# + 1 )
               zs_source  = zs_src_tmp[b_str# : e_str#]
           of   0
               zs_source  &= new String( len_source# )
               zs_source  = zs_src_tmp
      .

      !     
      Case AU 
           of  0  !  
               ret = self.ZB_Encode_and_Buffer(zs_source, len( zs_source ), rotate_angle)
           of  1  !   UTF-8
               utf8_string &= AtoU8(zs_source, len( zs_source ), utf8_length, CP_input)
               ret = self.ZB_Encode_and_Buffer(utf8_string,  utf8_length, rotate_angle)
      .  

      !   BitMap  : image_format -> BMP, pixel_format -> 32
      bitCount# = 32
      BitMap_size# = self.ZS.bitmap_width * self.ZS.bitmap_height * (bitCount# / 8)
      BitMap &= new String ( BitMap_size# ) 

      j# = 1
      adr_Bitmap#  = address(self.ZS.bitmap)
      size_Bitmap# = self.ZS.bitmap_height * self.ZS.bitmap_width * 3 - 1

      Loop pos#=0 to size_Bitmap# by 3
           peek(adr_Bitmap# + pos#, rgb)
           BitMap[j#] = rgB[3] ; j# += 1
           BitMap[j#] = rGb[2] ; j# += 1
           BitMap[j#] = Rgb[1] ; j# += 1
           BitMap[j#] = chr(0) ; j# += 1
      .
      
      hDC         = CreateCompatibleDC(0)
      Hbitmap_DIB = CreateBitmap(self.ZS.bitmap_width, self.ZS.bitmap_height, 1, bitCount#, address(BitMap))

      GdipCreateBitmapFromHBITMAP (Hbitmap_DIB, 0, GpImg)
      CreateStreamOnHGlobal (0, 0, GStream) !<>0
      GetHGlobalFromStream (GStream, GMem)

      !          Mem2Str
      GdipCloneBitmapAreaI(0, 0, self.ZS.bitmap_width, self.ZS.bitmap_height, PixelFormat.val, GpImg, GpImg_clone)
      GdipSaveImageToStream(GpImg_clone, GStream, CLSID.CLSID)
      GMem = GlobalLock(GMem)
      Mem2Str &= new String( GlobalSize(GMem) )
      peek (GMem, Mem2Str)

      !     ,      
      If clip(name_file) <> '' then 
         filename    &=  new String(pl# + 1)
         filename_w  &=  new String((pl# + 1) * 2)
         filename     =  clip(name_file) & '.' & image_format & chr(0)
         filename_w   =  AtoU16(filename)
         ret = GdipSaveImageToFile(GpImg_clone, filename_w, CLSID.CLSID)
      .

      DeleteObject(Hbitmap_DIB)
      DeleteDC(hDC)
      GdipDisposeImage(GpImg)
      GdipDisposeImage(GpImg_clone)
      GlobalFree(GMem)
      GlobalFree(GStream)
      
      !  
      Dispose(zs_source)
      Dispose(zs_src_tmp)
      Dispose(utf8_string)
      Dispose(SNFE)
      Dispose(BitMap)
      Dispose(filename)
      Dispose(filename_w)
     
   Return Mem2Str


!----------------------------------------------------------------------------------------------------------------------------------
Gdiplus_Init  Procedure()
!
!  GDI+
!
GdiplusStartupInput  string('<1>'&'<0>{15}')
GdiplusStartupOutput string(8)

   Code

      err# = GdiplusStartup(GdiplusToken, GdiplusStartupInput, GdiplusStartupOutput)
      If err# <> 0 then Return err#.

      err# = GetArrayEncoderClsid()
      If err# <> 0 then Return err#.

    Return  0


!----------------------------------------------------------------------------------------------------------------------------------
GetArrayEncoderClsid  Procedure()
!
!   CLSID  GDI+   
!
num_ICI      ulong(0)    
size_ICI     ulong(0)    
sizeG_ICI    ulong(0) 
address_ICI  ulong(0)
array_ICI    &string

extC  cstring(10)
extS  string(10)

ImageCodecInfo  Group(ImageCodecInfo_T).

   code

      err# = GdipGetImageEncodersSize(num_ICI, size_ICI)
      if err# <> 0  then return err#.
 
      array_ICI &= new String(size_ICI)
      err# = GdipGetImageEncoders(num_ICI, size_ICI, array_ICI)

      clear(ImageCodecInfo)
      sizeG_ICI = size(ImageCodecInfo)
      address_ICI = address(array_ICI)

      loop i#=1 to num_ICI
           peek(address_ICI + sizeG_ICI*(i#-1), ImageCodecInfo)
           peek(address(ImageCodecInfo.FormatDescription), extS)

           extC = U16toA(extS)
           extS = extC

           CLSID.extp  = extS
           peek(address(ImageCodecInfo.ClassID), CLSID.CLSID)
           add(CLSID)
      .
      
      PixelFormat.index =   1;  PixelFormat.val = 030101H ; add(PixelFormat)  ! PixelFormat_1bppIndexed
      PixelFormat.index =   4;  PixelFormat.val = 030402H ; add(PixelFormat)  ! PixelFormat_4bppIndexed
      PixelFormat.index =   8;  PixelFormat.val = 030803H ; add(PixelFormat)  ! PixelFormat_8bppIndexed
      PixelFormat.index =  16;  PixelFormat.val = 021006H ; add(PixelFormat)  ! PixelFormat16bppRGB565
      PixelFormat.index =  24;  PixelFormat.val = 021808H ; add(PixelFormat)  ! PixelFormat_24bppRGB
      PixelFormat.index =  32;  PixelFormat.val = 022009H ; add(PixelFormat)  ! PixelFormat_32bppRGB

      dispose(array_ICI)

    Return 0


!----------------------------------------------------------------------------------------------------------------------------------
AtoU8 Procedure(*string source, long length, *long UTF8_len, ulong CP_input)
!
!  ANSI  (source)  UTF-8  (UTF8_str)
!
UTF16_len  long
UTF16_str  &string
UTF8_str   &string

   Code

      rc#         =  MultiByteToWideChar(CP_input, 0, address(source), length, 0, 0)
      UTF16_len   =  rc# * 2 
      UTF16_str  &=  new String( UTF16_len ) 
      rc#         =  MultiByteToWideChar(CP_input, 0, address(source), length, address(UTF16_str), UTF16_len)

      rb#         =  WideCharToMultiByte(65001, 0, address(UTF16_str), rc#, 0, 0, 0, 0)
      UTF8_str   &=  new String( rb# ) 
      UTF8_len    =  WideCharToMultiByte(65001, 0, address(UTF16_str), rc#, address(UTF8_str), rb#, 0, 0)

      dispose(UTF16_str)

   Return  UTF8_str


!----------------------------------------------------------------------------------------------------------------------------------
AtoU16  Procedure(*string source, ulong CP_input)
!
!  ANSI  (source)  UTF-16  (UTF16_str)
!
len_source long
UTF16_len  long
UTF16_str  &string

   Code

      len_source  = len( clip(source) )
      rc#         =  MultiByteToWideChar(CP_input, 0, address(source), len_source, 0, 0)
      UTF16_len   =  rc# * 2 
      UTF16_str  &=  new String( UTF16_len ) 
      rc#         =  MultiByteToWideChar(CP_input, 0, address(source), len_source, address(UTF16_str), UTF16_len)

   Return UTF16_str


!----------------------------------------------------------------------------------------------------------------------------------
U16toA Procedure(*string source, ulong CP_input)
!
!  UTF-16  (source)  ANSI  (A_str)
!
len_source long
Astr_len  long
Astr     &string

   code

      len_source  = len( clip(source) )
      rc# = WideCharToMultiByte(CP_input, 0, address(source), len_source, 0, 0)

      Astr_len = rc#
      Astr &= new String( Astr_len )
      ac# = WideCharToMultiByte(CP_input, 0, address(source), len_source, address(Astr), Astr_len)

  return  Astr


!----------------------------------------------------------------------------------------------------------------------------------
load_libs  Procedure()
!
!   
!
name_dll   cstring(32)
name_proc  cstring(32)
 
   Code

      ! msvcrt.dll -------------------------------------------------------------------------------------------------------
      name_dll   = 'msvcrt.dll' ; 
      adr_msvcrt = LoadLibrary (name_dll)

      name_proc = '_filelength' ;  h_size  = GetProcAddress (adr_msvcrt, name_proc)
      name_proc = '_open'       ;  h_open  = GetProcAddress (adr_msvcrt, name_proc)
      name_proc = '_read'       ;  h_read  = GetProcAddress (adr_msvcrt, name_proc)
      name_proc = '_close'      ;  h_close = GetProcAddress (adr_msvcrt, name_proc)
      
      ! gdiplus.dll ------------------------------------------------------------------------------------------------------
      name_dll    = 'gdiplus.dll'
      adr_Gdiplus = LoadLibrary(name_dll)

      name_proc = 'GdiplusStartup'               ;  h_GdiplusStartup              = GetProcAddress(adr_Gdiplus, name_proc)
      name_proc = 'GdiplusShutdown'              ;  h_GdiplusShutdown             = GetProcAddress(adr_Gdiplus, name_proc)
      name_proc = 'GdipCreateBitmapFromHBITMAP'  ;  h_GdipCreateBitmapFromHBITMAP = GetProcAddress(adr_Gdiplus, name_proc)  
      name_proc = 'GdipCloneBitmapAreaI'         ;  h_GdipCloneBitmapAreaI        = GetProcAddress(adr_Gdiplus, name_proc)          
      name_proc = 'GdipGetImageEncoders'         ;  h_GdipGetImageEncoders        = GetProcAddress(adr_Gdiplus, name_proc)
      name_proc = 'GdipGetImageEncodersSize'     ;  h_GdipGetImageEncodersSize    = GetProcAddress(adr_Gdiplus, name_proc)
      name_proc = 'GdipSaveImageToFile'          ;  h_GdipSaveImageToFile         = GetProcAddress(adr_Gdiplus, name_proc)
      name_proc = 'GdipLoadImageFromFile'        ;  h_GdipLoadImageFromFile       = GetProcAddress(adr_Gdiplus, name_proc)
      name_proc = 'GdipSaveImageToStream'        ;  h_GdipSaveImageToStream       = GetProcAddress(adr_Gdiplus, name_proc)
      name_proc = 'GdipDisposeImage'             ;  h_GdipDisposeImage            = GetProcAddress(adr_Gdiplus, name_proc)

   Return  GetLastError()


!----------------------------------------------------------------------------------------------------------------------------------
load_file  Procedure(any filename, *long filelength)
!
!   (filename)       (file_content)
!
file_content &string
ref_filename &cstring

fd long
fs ulong

     Code
 
      ref_filename &= new CString( len(left(clip(filename))) + 1)
      ref_filename = filename

      fd = fopen(ref_filename)
      fs = fsize(fd)
 
      file_content &= new String(fs)
      filelength = fread(fd, file_content, fs)
      fclose(fd)
      
      Dispose(ref_filename)
      
   Return file_content
